package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayButieBo;
import com.ruoyi.pay.domain.vo.PayButieVo;
import com.ruoyi.pay.domain.PayButie;
import com.ruoyi.pay.mapper.PayButieMapper;
import com.ruoyi.pay.service.IPayButieService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 补贴扣减Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayButieServiceImpl implements IPayButieService {

    private final PayButieMapper baseMapper;

    /**
     * 查询补贴扣减
     */
    @Override
    public PayButieVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询补贴扣减列表
     */
    @Override
    public TableDataInfo<PayButieVo> queryPageList(PayButieBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayButie> lqw = buildQueryWrapper(bo);
        Page<PayButieVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询补贴扣减列表
     */
    @Override
    public List<PayButieVo> queryList(PayButieBo bo) {
        LambdaQueryWrapper<PayButie> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayButie> buildQueryWrapper(PayButieBo bo) {
       // Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayButie> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayButie::getTenantId, bo.getTenantId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), PayButie::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getFixed()), PayButie::getFixed, bo.getFixed());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), PayButie::getType, bo.getType());
        lqw.eq(bo.getDeleted() != null, PayButie::getDeleted, bo.getDeleted());
        return lqw;
    }

    /**
     * 新增补贴扣减
     */
    @Override
    public Boolean insertByBo(PayButieBo bo) {
        PayButie add = BeanUtil.toBean(bo, PayButie.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改补贴扣减
     */
    @Override
    public Boolean updateByBo(PayButieBo bo) {
        PayButie update = BeanUtil.toBean(bo, PayButie.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayButie entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除补贴扣减
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
